class LuaScriptManager //this is a completly new coding style for me
{	
	class LuaScript : public ScriptImpClass
	{
		void Created(GameObject *obj);
		void Destroyed(GameObject *obj);
		void Killed(GameObject *obj,GameObject *shooter);
		void Damaged(GameObject *obj,GameObject *damager,float damage);
		void Custom(GameObject *obj,int message,int param,GameObject *sender);
		void Enemy_Seen(GameObject *obj,GameObject *seen);
		void Action_Complete(GameObject *obj,int action,ActionCompleteReason reason);
		void Timer_Expired(GameObject *obj,int number);
		void Animation_Complete(GameObject *obj,const char *anim);
		void Poked(GameObject *obj,GameObject *poker);
		void Entered(GameObject *obj,GameObject *enter);
		void Exited(GameObject *obj,GameObject *exit);
	};
	struct Script
	{
		char *script;
		lua_State *lua;
		ScriptRegistrant<LuaScript> *scriptreg;
	};
	static AutoStack<Script *> Scripts;
	static ScriptImpClass *Get_Script(GameObject *obj, int scriptID);
	static bool Report_Errors(lua_State *L, int status);
	static void RegisterScriptFunctions(lua_State *L);

	static int Lua_DestroyScript_Wrap(lua_State *L);
	static int Lua_Get_Float_Parameter_Wrap(lua_State *L);
	static int Lua_Get_Int_Parameter_Wrap(lua_State *L);
	static int Lua_Get_String_Parameter_Wrap(lua_State *L);
	static int Lua_Start_Timer_Wrap(lua_State *L);
public:
	static void AddScript(const char *LuaFile);
	static void Lua_DestroyScript(GameObject *obj, int scriptID);
	static float Lua_Get_Float_Parameter(GameObject *obj, int scriptID, const char *Name);
	static int Lua_Get_Int_Parameter(GameObject *obj, int scriptID, const char *Name);
	static const char *Lua_Get_String_Parameter(GameObject *obj, int scriptID, const char *Name);
	static void Lua_Start_Timer(GameObject *obj, int scriptID, float Time, int Number);
	static void Cleanup();
};

class LuaManager
{
	static bool Report_Errors(lua_State *L, int status);
	static AutoStack<lua_State *> Lua;
public:
	static void ShowBanner();
	static void LoadLua(const char *LuaFile);
	static void Cleanup();
	static void Call_Chat_Hook(int ID, int Type, const wchar_t *Msg);
	static void Call_Host_Hook(int ID, int Type, const char *Msg);
	static void Call_Player_Join_Hook(int ID, const char *Nick);
	static void Call_Player_Leave_Hook(int ID);
	static void Call_Level_Loaded_Hook();
	static void Call_GameOver_Hook();
	static void Call_Console_Output_Hook(const char *Output);
	static void Call_Version_Hook(int ID, float Ver);
	static void Call_DDE_Hook(const char *DDEStr);

	static void Purchase_Hook(BaseControllerClass *base, GameObject *purchaser, unsigned int cost, unsigned int preset,unsigned int purchaseret,const char *data);
	static void Call_Object_Hook(void *data, GameObject *obj);
};

class LuaSocketManager
{
	
	
	struct SocketInfo
	{
		int ID;
		SOCKET *Socket;
		AutoStack<char *> buffer;
		HANDLE Thread;
	};
	static CRITICAL_SECTION sync;
	static bool init;
	static AutoStack<SocketInfo *> Sockets;
public:
	
	static void **LuaSocketManager::Connect(const char *Host, int Port);
	static void Send(int ID, const char *Data);
	static const char *Recv(int ID);
	static DWORD WINAPI Thr(LPVOID param);
	static bool ValidSock(int ID);
	static void Disconnect(int ID);
	
	static void Cleanup();
	
	static int Lua_Connect_Wrap(lua_State *L);
	static int Lua_Send_Wrap(lua_State *L);
	static int Lua_Recv_Wrap(lua_State *L);
	static int Lua_ValidSock_Wrap(lua_State *L);
	static int Lua_Disconnect_Wrap(lua_State *L);
	static void Register(lua_State *L);
	
};

