template <class T> class AutoStack;

struct meminfo
{
	int Line;
	const char *File;
	void *Address;
};

void* operator new (size_t nbytes, const char *File, int Line);
void* operator new[](size_t nbytes, const char *File, int Line);
void* operator new (size_t nbytes);
void* operator new[](size_t nbytes);
void operator delete(void *ptr);
void operator delete[](void *ptr);
#pragma warning(disable: 4291)
void check_memory();
AutoStack<char *> GetFiles(const char *Path);

template <class T> class AutoStack
{
	T *Data;
	int Size;
	int Position;
public:
	AutoStack()
	{
		Data = (T *)malloc(sizeof(T));
		Size = 1;
		Position = 0;
	}

	 void __cdecl Push(T data)
	{
		T *Temp = (T *)malloc(sizeof(T)*Size);
		for(int i = 0; i < Size; i++)
		{
			Temp[i] = Data[i]; 
		}
		free(Data);
		Data = Temp;
		Data[Size-1] = data;
		Size++;
	}

	void NodeNext()
	{
		Position++;
	}

	T *Node()
	{
		if(End())
		{
			return 0;
		}
		
		return &Data[Position];
	}

	bool End()
	{
		if(Position >= Size-1)
		{
			return 1;
		}
		return 0;
	}
	void ResetPos()
	{
		Position = 0;
	}

	void DeleteAllNodes(bool Arr)
	{
		if(Size == 1)
		{
			
			return;
		}
		
		for(int i = 0; i < Size-1; i++)
		{
			if(Arr)
			{
				if(Data[i])
				{
					delete []Data[i];
				}
			}
			else
			{
				if(Data[i])
				{
					delete Data[i];
				}
			}
		}
	}
	void FreeAllNodes()
	{
		if(Size == 1)
		{
			return;
		}
		for(int i = 0; i < Size-1; i++)
		{
			free(Data[i]);
		}
	}
	void RemoveAllNodes()
	{
		free(Data);
		Data = (T *)malloc(sizeof(T));
		Size = 1;
		Position = 0;
	}		

};

//#define new new(__FILE__, __LINE__)